﻿using System.ComponentModel;
using System.Diagnostics.CodeAnalysis;
using Spectre.Console;
using Spectre.Console.Cli;

namespace PiwigoDirectorySync.Commands;

[SuppressMessage("ReSharper", "UnusedAutoPropertyAccessor.Global", Justification = "Done by parser")]
internal class CommonCommandSettings : CommandSettings
{
    [CommandArgument(0, "[PiwigoServerId]")]
    [DefaultValue(1)]
    public int PiwigoServerId { get; init; }

    public override ValidationResult Validate()
    {
        var baseResult = base.Validate();
        if (!baseResult.Successful)
        {
            return baseResult;
        }

        if (PiwigoServerId < 1)
        {
            return ValidationResult.Error("the piwigo server id can not be less than 1");
        }

        return ValidationResult.Success();
    }
}