﻿using Spectre.Console.Cli;

namespace PiwigoDirectorySync.Infrastructure;

internal sealed class DependencyTypeResolver : ITypeResolver, IDisposable
{
    private readonly IServiceProvider _provider;

    public DependencyTypeResolver(IServiceProvider provider)
    {
        _provider = provider ?? throw new ArgumentNullException(nameof(provider));
    }

    public void Dispose()
    {
        if (_provider is IDisposable disposable)
        {
            disposable.Dispose();
        }
    }

    public object? Resolve(Type? type) => type == null ? null : _provider.GetService(type);
}