﻿using System.Security.Cryptography;

namespace PiwigoDirectorySync.Infrastructure;

internal static class FilesystemHelpers
{
    public static async Task<string> CalculateMd5SumAsync(string imageFileFullPath, CancellationToken stoppingToken)
    {
        using var md5 = MD5.Create();
        await using var stream = File.OpenRead(imageFileFullPath);
        var hash = await md5.ComputeHashAsync(stream, stoppingToken);
        return BitConverter.ToString(hash).Replace("-", string.Empty).ToLowerInvariant();
    }
}