﻿using Microsoft.Extensions.Logging;
using Piwigo.Client;
using PiwigoDirectorySync.Persistence;

namespace PiwigoDirectorySync.Infrastructure;

internal class PiwigoClientFactory : IPiwigoClientFactory
{
    private readonly ILoggerFactory _loggerFactory;

    public PiwigoClientFactory(ILoggerFactory loggerFactory)
    {
        _loggerFactory = loggerFactory;
    }

    public async Task<IPiwigoClient> GetPiwigoClientAsync(ServerEntity piwigoServer, CancellationToken ct)
    {
        var piwigoClient = PiwigoClient.CreateClient(piwigoServer.Url, piwigoServer.Username, piwigoServer.Password, _loggerFactory);
        await piwigoClient.Session.LoginAsync(ct);
        return piwigoClient;
    }
}