﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace PiwigoDirectorySync.Migrations
{
    /// <inheritdoc />
    public partial class InitialCreate : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "PiwigoServers",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Name = table.Column<string>(type: "TEXT", nullable: false),
                    Url = table.Column<string>(type: "TEXT", nullable: false),
                    Username = table.Column<string>(type: "TEXT", nullable: false),
                    Password = table.Column<string>(type: "TEXT", nullable: false),
                    RootDirectory = table.Column<string>(type: "TEXT", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PiwigoServers", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "PiwigoAlbums",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    PiwigoAlbumId = table.Column<int>(type: "INTEGER", nullable: true),
                    DirectoryName = table.Column<string>(type: "TEXT", nullable: false),
                    ParentId = table.Column<int>(type: "INTEGER", nullable: true),
                    ServerId = table.Column<int>(type: "INTEGER", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PiwigoAlbums", x => x.Id);
                    table.ForeignKey(
                        name: "FK_PiwigoAlbums_PiwigoAlbums_ParentId",
                        column: x => x.ParentId,
                        principalTable: "PiwigoAlbums",
                        principalColumn: "Id");
                    table.ForeignKey(
                        name: "FK_PiwigoAlbums_PiwigoServers_ServerId",
                        column: x => x.ServerId,
                        principalTable: "PiwigoServers",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "PiwigoImages",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    ServerImageId = table.Column<int>(type: "INTEGER", nullable: true),
                    FilePath = table.Column<string>(type: "TEXT", nullable: false),
                    LastChange = table.Column<DateTime>(type: "TEXT", nullable: false),
                    Md5Sum = table.Column<string>(type: "TEXT", nullable: true),
                    AlbumId = table.Column<int>(type: "INTEGER", nullable: false),
                    UploadRequired = table.Column<bool>(type: "INTEGER", nullable: false),
                    DeleteRequired = table.Column<bool>(type: "INTEGER", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PiwigoImages", x => x.Id);
                    table.ForeignKey(
                        name: "FK_PiwigoImages_PiwigoAlbums_AlbumId",
                        column: x => x.AlbumId,
                        principalTable: "PiwigoAlbums",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_PiwigoAlbums_ParentId",
                table: "PiwigoAlbums",
                column: "ParentId");

            migrationBuilder.CreateIndex(
                name: "IX_PiwigoAlbums_PiwigoAlbumId",
                table: "PiwigoAlbums",
                column: "PiwigoAlbumId");

            migrationBuilder.CreateIndex(
                name: "IX_PiwigoAlbums_ServerId",
                table: "PiwigoAlbums",
                column: "ServerId");

            migrationBuilder.CreateIndex(
                name: "IX_PiwigoImages_AlbumId",
                table: "PiwigoImages",
                column: "AlbumId");

            migrationBuilder.CreateIndex(
                name: "IX_PiwigoServers_Name",
                table: "PiwigoServers",
                column: "Name",
                unique: true);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "PiwigoImages");

            migrationBuilder.DropTable(
                name: "PiwigoAlbums");

            migrationBuilder.DropTable(
                name: "PiwigoServers");
        }
    }
}
