using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using Microsoft.EntityFrameworkCore;

namespace PiwigoDirectorySync.Persistence;

[Index(nameof(ParentId))]
[Index(nameof(ServerAlbumId))]
[Index(nameof(ServerId), nameof(Path), IsUnique = true)]
public class AlbumEntity
{
    [Key]
    [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
    public int Id { get; set; }

    public int? ServerAlbumId { get; set; }
    public required string Name { get; set; }
    public required string Path { get; set; }

    public int? ParentId { get; set; }
    public AlbumEntity? Parent { get; set; }

    public required int ServerId { get; set; }
    public ServerEntity Server { get; set; } = null!;
}