﻿using Microsoft.EntityFrameworkCore;

namespace PiwigoDirectorySync.Persistence;

public static class ExtensionMethods
{
    public static Task<ServerEntity?> FindByIdAsync(this DbSet<ServerEntity> dbSet, int serverId, CancellationToken ct)
    {
        return dbSet.Where(a => a.Id == serverId).FirstOrDefaultAsync(ct);
    }
    public static Task<ServerEntity> GetByIdAsync(this DbSet<ServerEntity> dbSet, int serverId, CancellationToken ct)
    {
        return dbSet.Where(a => a.Id == serverId).FirstAsync(ct);
    }

    public static async Task<AlbumEntity?> FindByServerAndPathAsync(this DbSet<AlbumEntity> dbSet, int serverId, string relativePath, CancellationToken ct)
    {
        return await dbSet.Where(a => a.ServerId == serverId && a.Path == relativePath).FirstOrDefaultAsync(ct);
    }

    public static async Task<AlbumEntity?> FindByServerIdAsync(this DbSet<AlbumEntity> dbSet, int piwigoServerId, int serverAlbumId, CancellationToken ct)
    {
        return await dbSet.Where(a => a.ServerId == piwigoServerId && a.ServerAlbumId == serverAlbumId).FirstOrDefaultAsync(ct);
    }

    public static Task<AlbumEntity> GetByIdAsync(this DbSet<AlbumEntity> dbSet, int serverId, CancellationToken ct)
    {
        return dbSet.Where(a => a.Id == serverId).FirstAsync(ct);
    }
}